tests: init.sh improvements for re-exec'ing with zsh
[pspp] / tests / init.sh
1 # source this file; set up for tests
2
3 # Copyright (C) 2009, 2010 Free Software Foundation, Inc.
4
5 # This program is free software: you can redistribute it and/or modify
6 # it under the terms of the GNU General Public License as published by
7 # the Free Software Foundation, either version 3 of the License, or
8 # (at your option) any later version.
9
10 # This program is distributed in the hope that it will be useful,
11 # but WITHOUT ANY WARRANTY; without even the implied warranty of
12 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
13 # GNU General Public License for more details.
14
15 # You should have received a copy of the GNU General Public License
16 # along with this program.  If not, see <http://www.gnu.org/licenses/>.
17
18 # Using this file in a test
19 # =========================
20 #
21 # The typical skeleton of a test looks like this:
22 #
23 #   #!/bin/sh
24 #   . "${srcdir=.}/init.sh"; path_prepend_ .
25 #   Execute some commands.
26 #   Note that these commands are executed in a subdirectory, therefore you
27 #   need to prepend "../" to relative filenames in the build directory.
28 #   Note that the "path_prepend_ ." is useful only if the body of your
29 #   test invokes programs residing in the initial directory.
30 #   For example, if the programs you want to test are in src/, and this test
31 #   script is named tests/test-1, then you would use "path_prepend_ ../src",
32 #   or perhaps export PATH='$(abs_top_builddir)/src$(PATH_SEPARATOR)'"$$PATH"
33 #   to all tests via automake's TESTS_ENVIRONMENT.
34 #   Set the exit code 0 for success, 77 for skipped, or 1 or other for failure.
35 #   Use the skip_ and fail_ functions to print a diagnostic and then exit
36 #   with the corresponding exit code.
37 #   Exit $?
38
39 # Executing a test that uses this file
40 # ====================================
41 #
42 # Running a single test:
43 #   $ make check TESTS=test-foo.sh
44 #
45 # Running a single test, with verbose output:
46 #   $ make check TESTS=test-foo.sh VERBOSE=yes
47 #
48 # Running a single test, with single-stepping:
49 #   1. Go into a sub-shell:
50 #   $ bash
51 #   2. Set relevant environment variables from TESTS_ENVIRONMENT in the
52 #      Makefile:
53 #   $ export srcdir=../../tests # this is an example
54 #   3. Execute the commands from the test, copy&pasting them one by one:
55 #   $ . "$srcdir/init.sh"; path_prepend_ .
56 #   ...
57 #   4. Finally
58 #   $ exit
59
60 ME_=`expr "./$0" : '.*/\(.*\)$'`
61
62 # We use a trap below for cleanup.  This requires us to go through
63 # hoops to get the right exit status transported through the handler.
64 # So use `Exit STATUS' instead of `exit STATUS' inside of the tests.
65 # Turn off errexit here so that we don't trip the bug with OSF1/Tru64
66 # sh inside this function.
67 Exit () { set +e; (exit $1); exit $1; }
68
69 # Print warnings (e.g., about skipped and failed tests) to this file number.
70 # Override by defining to say, 9, in init.cfg, and putting say,
71 # "export ...ENVVAR_SETTINGS...; exec 9>&2; $(SHELL)" in the definition
72 # of TESTS_ENVIRONMENT in your tests/Makefile.am file.
73 # This is useful when using automake's parallel tests mode, to print
74 # the reason for skip/failure to console, rather than to the .log files.
75 : ${stderr_fileno_=2}
76
77 warn_() { echo "$@" 1>&$stderr_fileno_; }
78 fail_() { warn_ "$ME_: failed test: $@"; Exit 1; }
79 skip_() { warn_ "$ME_: skipped test: $@"; Exit 77; }
80 framework_failure_() { warn_ "$ME_: set-up failure: $@"; Exit 99; }
81
82 # Sanitize this shell to POSIX mode, if possible.
83 DUALCASE=1; export DUALCASE
84 if test -n "${ZSH_VERSION+set}" && (emulate sh) >/dev/null 2>&1; then
85   emulate sh
86   NULLCMD=:
87   alias -g '${1+"$@"}'='"$@"'
88   setopt NO_GLOB_SUBST
89 else
90   case `(set -o) 2>/dev/null` in
91     *posix*) set -o posix ;;
92   esac
93 fi
94
95 # We require $(...) support unconditionally.
96 # We require a few additional shell features only when $EXEEXT is nonempty,
97 # in order to support automatic $EXEEXT emulation:
98 # - hyphen-containing alias names
99 # - we prefer to use ${var#...} substitution, rather than having
100 #   to work around lack of support for that feature.
101 # The following code attempts to find a shell with support for these features.
102 # If the current shell passes the test, we're done.  Otherwise, test other
103 # shells until we find one that passes.  If one is found, re-exec it.
104 # If no acceptable shell is found, skip the current test.
105 #
106 # Use "9" to indicate success (rather than 0), in case some shell acts
107 # like Solaris 10's /bin/sh but exits successfully instead of with status 2.
108
109 gl_shell_test_script_='
110 test $(echo y) = y || exit 1
111 test -z "$EXEEXT" && exit 9
112 shopt -s expand_aliases
113 alias a-b="echo zoo"
114 v=abx
115      test ${v%x} = ab \
116   && test ${v#a} = bx \
117   && test $(a-b) = zoo \
118   && exit 9
119 '
120
121 if test "x$1" = "x--no-reexec"; then
122   shift
123 else
124   # 'eval'ing the above code makes Solaris 10's /bin/sh exit with $? set to 2.
125   # It does not evaluate any of the code after the "unexpected" `('.  Thus,
126   # we must run it in a subshell.
127   ( eval "$gl_shell_test_script_" ) > /dev/null 2>&1
128   if test $? = 9; then
129     : # The current shell is adequate.  No re-exec required.
130   else
131     # Search for a shell that meets our requirements.
132     for re_shell_ in "${CONFIG_SHELL:-no_shell}" /bin/sh bash dash zsh pdksh fail
133     do
134       test "$re_shell_" = no_shell && continue
135       test "$re_shell_" = fail && skip_ failed to find an adequate shell
136       "$re_shell_" -c "$gl_shell_test_script_" 2>/dev/null
137       if test $? = 9; then
138         # Found an acceptable shell.  Preserve -v and -x.
139         case $- in
140           *v*x* | *x*v*) opts_=-vx ;;
141           *v*) opts_=-v ;;
142           *x*) opts_=-x ;;
143           *) opts_= ;;
144         esac
145         exec "$re_shell_" $opts_ "$0" --no-reexec "$@"
146         echo "$ME_: exec failed" 1>&2
147         exit 127
148       fi
149     done
150   fi
151 fi
152
153 test -n "$EXEEXT" && shopt -s expand_aliases
154
155 # Enable glibc's malloc-perturbing option.
156 # This is cheap and useful for exposing code that depends on the fact that
157 # malloc-related functions often return memory that is mostly zeroed.
158 # If you have the time and cycles, use valgrind to do an even better job.
159 : ${MALLOC_PERTURB_=87}
160 export MALLOC_PERTURB_
161
162 # This is a stub function that is run upon trap (upon regular exit and
163 # interrupt).  Override it with a per-test function, e.g., to unmount
164 # a partition, or to undo any other global state changes.
165 cleanup_() { :; }
166
167 if ( diff --version < /dev/null 2>&1 | grep GNU ) > /dev/null 2>&1; then
168   compare() { diff -u "$@"; }
169 elif ( cmp --version < /dev/null 2>&1 | grep GNU ) > /dev/null 2>&1; then
170   compare() { cmp -s "$@"; }
171 else
172   compare() { cmp "$@"; }
173 fi
174
175 # An arbitrary prefix to help distinguish test directories.
176 testdir_prefix_() { printf gt; }
177
178 # Run the user-overridable cleanup_ function, remove the temporary
179 # directory and exit with the incoming value of $?.
180 remove_tmp_()
181 {
182   __st=$?
183   cleanup_
184   # cd out of the directory we're about to remove
185   cd "$initial_cwd_" || cd / || cd /tmp
186   chmod -R u+rwx "$test_dir_"
187   # If removal fails and exit status was to be 0, then change it to 1.
188   rm -rf "$test_dir_" || { test $__st = 0 && __st=1; }
189   exit $__st
190 }
191
192 # Given a directory name, DIR, if every entry in it that matches *.exe
193 # contains only the specified bytes (see the case stmt below), then print
194 # a space-separated list of those names and return 0.  Otherwise, don't
195 # print anything and return 1.  Naming constraints apply also to DIR.
196 find_exe_basenames_()
197 {
198   feb_dir_=$1
199   feb_fail_=0
200   feb_result_=
201   feb_sp_=
202   for feb_file_ in $feb_dir_/*.exe; do
203     case $feb_file_ in
204       *[!-a-zA-Z/0-9_.+]*) feb_fail_=1; break;;
205       *) # Remove leading file name components as well as the .exe suffix.
206          feb_file_=${feb_file_##*/}
207          feb_file_=${feb_file_%.exe}
208          feb_result_="$feb_result_$feb_sp_$feb_file_";;
209     esac
210     feb_sp_=' '
211   done
212   test $feb_fail_ = 0 && printf %s "$feb_result_"
213   return $feb_fail_
214 }
215
216 # Consider the files in directory, $1.
217 # For each file name of the form PROG.exe, create an alias named
218 # PROG that simply invokes PROG.exe, then return 0.  If any selected
219 # file name or the directory name, $1, contains an unexpected character,
220 # define no function and return 1.
221 create_exe_shims_()
222 {
223   case $EXEEXT in
224     '') return 0 ;;
225     .exe) ;;
226     *) echo "$0: unexpected \$EXEEXT value: $EXEEXT" 1>&2; return 1 ;;
227   esac
228
229   base_names_=`find_exe_basenames_ $1` \
230     || { echo "$0 (exe_shim): skipping directory: $1" 1>&2; return 1; }
231
232   if test -n "$base_names_"; then
233     for base_ in $base_names_; do
234       alias "$base_"="$base_$EXEEXT"
235     done
236   fi
237
238   return 0
239 }
240
241 # Use this function to prepend to PATH an absolute name for each
242 # specified, possibly-$initial_cwd_-relative, directory.
243 path_prepend_()
244 {
245   while test $# != 0; do
246     path_dir_=$1
247     case $path_dir_ in
248       '') fail_ "invalid path dir: '$1'";;
249       /*) abs_path_dir_=$path_dir_;;
250       *) abs_path_dir_=`cd "$initial_cwd_/$path_dir_" && echo "$PWD"` \
251            || fail_ "invalid path dir: $path_dir_";;
252     esac
253     case $abs_path_dir_ in
254       *:*) fail_ "invalid path dir: '$abs_path_dir_'";;
255     esac
256     PATH="$abs_path_dir_:$PATH"
257
258     # Create an alias, FOO, for each FOO.exe in this directory.
259     create_exe_shims_ "$abs_path_dir_" \
260       || fail_ "something failed (above): $abs_path_dir_"
261     shift
262   done
263   export PATH
264 }
265
266 setup_()
267 {
268   test "$VERBOSE" = yes && set -x
269
270   initial_cwd_=$PWD
271
272   pfx_=`testdir_prefix_`
273   test_dir_=`mktempd_ "$initial_cwd_" "$pfx_-$ME_.XXXX"` \
274     || fail_ "failed to create temporary directory in $initial_cwd_"
275   cd "$test_dir_"
276
277   # This trap statement, along with a trap on 0 below, ensure that the
278   # temporary directory, $test_dir_, is removed upon exit as well as
279   # upon receipt of any of the listed signals.
280   for sig_ in 1 2 3 13 15; do
281     eval "trap 'Exit $(expr $sig_ + 128)' $sig_"
282   done
283 }
284
285 # Create a temporary directory, much like mktemp -d does.
286 # Written by Jim Meyering.
287 #
288 # Usage: mktempd_ /tmp phoey.XXXXXXXXXX
289 #
290 # First, try to use the mktemp program.
291 # Failing that, we'll roll our own mktemp-like function:
292 #  - try to get random bytes from /dev/urandom
293 #  - failing that, generate output from a combination of quickly-varying
294 #      sources and gzip.  Ignore non-varying gzip header, and extract
295 #      "random" bits from there.
296 #  - given those bits, map to file-name bytes using tr, and try to create
297 #      the desired directory.
298 #  - make only $MAX_TRIES_ attempts
299
300 # Helper function.  Print $N pseudo-random bytes from a-zA-Z0-9.
301 rand_bytes_()
302 {
303   n_=$1
304
305   # Maybe try openssl rand -base64 $n_prime_|tr '+/=\012' abcd first?
306   # But if they have openssl, they probably have mktemp, too.
307
308   chars_=abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789
309   dev_rand_=/dev/urandom
310   if test -r "$dev_rand_"; then
311     # Note: 256-length($chars_) == 194; 3 copies of $chars_ is 186 + 8 = 194.
312     dd ibs=$n_ count=1 if=$dev_rand_ 2>/dev/null \
313       | LC_ALL=C tr -c $chars_ 01234567$chars_$chars_$chars_
314     return
315   fi
316
317   n_plus_50_=`expr $n_ + 50`
318   cmds_='date; date +%N; free; who -a; w; ps auxww; ps ef; netstat -n'
319   data_=` (eval "$cmds_") 2>&1 | gzip `
320
321   # Ensure that $data_ has length at least 50+$n_
322   while :; do
323     len_=`echo "$data_"|wc -c`
324     test $n_plus_50_ -le $len_ && break;
325     data_=` (echo "$data_"; eval "$cmds_") 2>&1 | gzip `
326   done
327
328   echo "$data_" \
329     | dd bs=1 skip=50 count=$n_ 2>/dev/null \
330     | LC_ALL=C tr -c $chars_ 01234567$chars_$chars_$chars_
331 }
332
333 mktempd_()
334 {
335   case $# in
336   2);;
337   *) fail_ "Usage: $ME DIR TEMPLATE";;
338   esac
339
340   destdir_=$1
341   template_=$2
342
343   MAX_TRIES_=4
344
345   # Disallow any trailing slash on specified destdir:
346   # it would subvert the post-mktemp "case"-based destdir test.
347   case $destdir_ in
348   /) ;;
349   */) fail_ "invalid destination dir: remove trailing slash(es)";;
350   esac
351
352   case $template_ in
353   *XXXX) ;;
354   *) fail_ "invalid template: $template_ (must have a suffix of at least 4 X's)";;
355   esac
356
357   fail=0
358
359   # First, try to use mktemp.
360   d=`unset TMPDIR; mktemp -d -t -p "$destdir_" "$template_" 2>/dev/null` \
361     || fail=1
362
363   # The resulting name must be in the specified directory.
364   case $d in "$destdir_"*);; *) fail=1;; esac
365
366   # It must have created the directory.
367   test -d "$d" || fail=1
368
369   # It must have 0700 permissions.  Handle sticky "S" bits.
370   perms=`ls -dgo "$d" 2>/dev/null|tr S -` || fail=1
371   case $perms in drwx------*) ;; *) fail=1;; esac
372
373   test $fail = 0 && {
374     echo "$d"
375     return
376   }
377
378   # If we reach this point, we'll have to create a directory manually.
379
380   # Get a copy of the template without its suffix of X's.
381   base_template_=`echo "$template_"|sed 's/XX*$//'`
382
383   # Calculate how many X's we've just removed.
384   template_length_=`echo "$template_" | wc -c`
385   nx_=`echo "$base_template_" | wc -c`
386   nx_=`expr $template_length_ - $nx_`
387
388   err_=
389   i_=1
390   while :; do
391     X_=`rand_bytes_ $nx_`
392     candidate_dir_="$destdir_/$base_template_$X_"
393     err_=`mkdir -m 0700 "$candidate_dir_" 2>&1` \
394       && { echo "$candidate_dir_"; return; }
395     test $MAX_TRIES_ -le $i_ && break;
396     i_=`expr $i_ + 1`
397   done
398   fail_ "$err_"
399 }
400
401 # If you want to override the testdir_prefix_ function,
402 # or to add more utility functions, use this file.
403 test -f "$srcdir/init.cfg" \
404   && . "$srcdir/init.cfg"
405
406 setup_ "$@"
407 # This trap is here, rather than in the setup_ function, because some
408 # shells run the exit trap at shell function exit, rather than script exit.
409 trap remove_tmp_ 0